import { HardhatRuntimeEnvironment } from "hardhat/types";
import { DeployFunction } from "hardhat-deploy/types";
import { updateArray } from "../scripts/utils"


const deployNFTClaim: DeployFunction = 
  async function (hre: HardhatRuntimeEnvironment) {
    const provider = hre.ethers.provider;
    const from = await (await provider.getSigner()).getAddress();

    const verifier = '0x50A8e60041A206AcaA5F844a1104896224be6F39'
    const ret = await hre.deployments.deploy("NFTLock", {
      from,
      args: [3600, verifier],
      log: true,
    });
    console.log("==NFTLock addr=", ret.address);
    updateArray({
      name: "NFTLock",
      type: "logic",
      json: "assets/contracts/NFTLock.json",
      address: ret.address,
      network: hre.network.name,
    });
  };

  deployNFTClaim.tags = ["NFTLock"];

export default deployNFTClaim;
